package hiedabke_zgpf

import (
	"git.swzry.com/zry/GoHiedaLogger/hiedalog"
	zgpf "git.swzry.com/zry/zry-go-program-framework/core"
)

var _ hiedalog.HiedaLogBackend = (*ZGPFModuleLoggerBackend)(nil)

type ZGPFModuleLoggerBackend struct {
	baseLogger zgpf.IModuleLogger
}

func NewZGPFModuleLoggerBackend(base zgpf.IModuleLogger) *ZGPFModuleLoggerBackend {
	return &ZGPFModuleLoggerBackend{baseLogger: base}
}

func (b *ZGPFModuleLoggerBackend) EmitStringLog(module string, level hiedalog.HiedaLogLevel, content string) {
	l := b.baseLogger.GetSubLog(module)
	switch level.LevelNumber {
	default:
		l.Debug(content)
		break
	case 0:
		l.Fatal(content)
		break
	case 1:
		l.Panic(content)
		break
	case 2:
		l.Error(content)
		break
	case 3:
		l.Warn(content)
		break
	case 4:
		l.Info(content)
		break
	case 5:
		l.Verbose(content)
		break
	}
}

func (b *ZGPFModuleLoggerBackend) EmitComplexLog(module string, level hiedalog.HiedaLogLevel, data map[string]string) {
	l := b.baseLogger.GetSubLog(module)
	switch level.LevelNumber {
	default:
		l.DebugC(data)
		break
	case 0:
		l.FatalC(data)
		break
	case 1:
		l.PanicC(data)
		break
	case 2:
		l.ErrorC(data)
		break
	case 3:
		l.WarnC(data)
		break
	case 4:
		l.InfoC(data)
		break
	case 5:
		l.VerboseC(data)
		break
	}
}
